#version 130

uniform mat4 perspective;
uniform mat4 view;
uniform mat4 model;
uniform mat4 shadowMapTextureMatrix;
uniform vec3 point_light_position;
//uniform vec3 direct_light_direction;
uniform vec3 direct_light_position;

in vec3 vertex;
in vec3 normal;
in vec4 color;
in vec2 uvs;

out vec3 normal_view;
out vec4 position_view;
out vec4 vert_color;
out vec2 vert_uvs;
out vec4 point_light_position_view;
//out vec3 direct_light_direction_view;
out vec4 direct_light_position_view;
out vec4 shadowMapTextureCoordinates;

void main(void)
{
	// ausgabe zum Fragment Shader in ViewSpace Coord
    normal_view = (view * model * vec4(normal, 0.0f)).xyz;
    position_view = view * model * vec4(vertex, 1.0);
        
    gl_Position = perspective * view * model * vec4(vertex, 1.0);
    
    point_light_position_view = view * vec4(point_light_position, 1.0f);
    direct_light_position_view = view * vec4(direct_light_position, 1.0);
    
    vert_color = color;
    vert_uvs = uvs;
    
    shadowMapTextureCoordinates = shadowMapTextureMatrix * model * vec4(vertex, 1.0);
}
